from constraint import *

def fun(S,E,N,D,M,O,R,Y):
   L1 = 1000*S + 100*E + 10*N + D
   L2 = 1000*M + 100*O + 10*R + E
   L3 = 10000*M + 1000*O + 100*N + 10*E + Y
#   print L1, L2, L3
   return L3 == L1+L2

# print fun(9,5,6,7,1,0,8,2)
# print fun(1,2,3,4,5,6,7,8)

problem = Problem()
# problem.addVariables(['S','E','N','D','M','O','R','Y'],[0,1,2,3,4,5,6,7,8,9])
problem.addVariables(['S','E','N','D','M','O','R','Y'],range(0,10))
problem.addConstraint(AllDifferentConstraint())
problem.addConstraint(lambda M: M > 0, ['M'])
problem.addConstraint(lambda S: S > 0, ['S'])
problem.addConstraint(fun,['S','E','N','D','M','O','R','Y'])

# for solution in problem.getSolutions():
#   print solution
   
solutions = problem.getSolutions()
print(solutions)

